var canvasClick;
var canvasMouseMove;

var zooming;
var coords;

function initLayout() {
	canvasMouseMove = function(event) {
		var cell = toCellCoord(event);
		var req = "/war/element.yaml?x=" + cell.x + "&y=" + cell.y + "&zoom=" + zooming + "&coord=" + coords;
		$.get(req, function (data) {
			var newStatus = " (" + cell.x + ", " + cell.y + ")";
	    	var el = YAML.parse(data);
	    	if(el) {
	    		var train = el.train;
	    		if(train) {
	    			newStatus = newStatus + " - train " + train.name + " to " + train.to + " " + train.status;
	    			if(train.etd) {
	    				newStatus = newStatus + " ETD: " + train.etd;
	    			}
	    		} else if (el.element) {
	    			var trk = el.element;
	    			var type = trk.type;
	    			if(type == 'track') {
	    				if(trk.name && trk.name != '') {
	    					newStatus = newStatus + " - " + trk.name;
	    				}
	    				if(trk.length > 0) {
	    					newStatus = newStatus + "  length: " + trk.length;
	    				}
	    				if(trk.speeds) {
	    					newStatus = newStatus + " " + trk.speeds;
	    				}
	    			} else if(type == 'signal') {
	    				newStatus = newStatus + " - signal ";
	    				if(trk.name && trk.name != '') {
	    					newStatus = newStatus + "  " + trk.name;
	    				}
	    				if(trk.controls) {
	    					newStatus = newStatus + " controls " + trk.controls;
	    				}
	    				newStatus = newStatus + " aspect " + trk.aspect;
	    			}
	    		}
	    	}
	    	$("#curStatus").html(newStatus);
	    	showTime();
		});
	};
	canvasClick = function(event) {
		doCanvasClick(event);
	};
	$("#canvas").mousemove(canvasMouseMove);
	$("#canvas").click(canvasClick);
}

function reloadCanvas() {
    $("#canvas").attr("src", "/war/canvas?i=" + new Date().getTime());
}

function toCellCoord(event) {
    var ycoord = event.pageY - event.target.y;
    ycoord = Math.floor(ycoord / 9);
	var pos = { x: Math.floor(((event.pageX - event.target.x) / 9)), y: ycoord };
	return pos;
}

function resumeRunning(prevStatus) {
	if (prevStatus.status.prev == 'running') {
		$.get('/war/play.yaml', function(res) {
			
		});
	}
}

function reverseTrain(train) {
	var prevStatus;
	$.get('/war/pause.yaml', function(prev) {
		prevStatus = YAML.parse(prev);
		BootstrapDialog.show({
            message: 'Reverse Train Direction?',
            buttons: [{
                label: 'Reverse',
                action: function(dialogItself) {
                    dialogItself.close();
                    var cmd = "reverse " + train.name;
                    doCommandAndThen(cmd, function (res) {
                    	resumeRunning(prevStatus);
                    });
                }
            }, {
                label: 'Cancel',
                action: function(dialogItself){
                    dialogItself.close();
                }
            }]
        });
	});
}

function shuntTrain(train) {
	var prevStatus;
	$.get('/war/pause.yaml', function(prev) {
		prevStatus = YAML.parse(prev);
		BootstrapDialog.show({
            message: 'Proceed to next station?',
            buttons: [{
                label: 'Proceed',
                action: function(dialogItself) {
                    dialogItself.close();
                    var cmd = "shunt " + train.name;
                    doCommandAndThen(cmd, function (res) {
                    	resumeRunning(prevStatus);
                    });
                }
            }, {
                label: 'Cancel',
                action: function(dialogItself){
                    dialogItself.close();
                }
            }]
        });
	});
}

function doCanvasClick(event) {
	var cell = toCellCoord(event);
	var req = "/war/element.yaml?x=" + cell.x + "&y=" + cell.y + "&zoom=" + zooming + "&coord=" + coords;
	$.get(req, function (data) {
    	var el = YAML.parse(data);
    	if (el) {
    		var train = el.train;
    		if(train) {
    			if(event.ctrlKey) { // ctrl+click: shunt train
    				if(train.status == 'arrived') { // and not shunting
    					doAssignDialog(train.name);
    					return;
    				}
    				if(train.status == 'stopped' || train.status == 'waiting') {
    					shuntTrain(train);
    				} else {
    					// error: train must be stopped
    				}
    				return;
    			}
    			// default: reverse train
    			if(train.status == 'stopped' || train.status == 'waiting' || train.status == 'arrived') {
    				reverseTrain(train);
    			} else {
    				// error: train must be stopped
    			}
    			return;
    		}
    	}
    	req = "/war/click?x=" + cell.x + "&y=" + cell.y + "&zoom=" + zooming + "&coord=" + coords;
    	req += "&shift=" + (event.shiftKey ? "1" : "0");
    	req += "&alt=" + (event.altKey ? "1" : "0");
    	req += "&ctrl=" + (event.ctrlKey ? "1" : "0");
    	req += "&btn=" + event.which;
    	$.getJSON(req, function(data) {
    		
    	}).fail(function() {
    		console.log("fail");
    	});
/*    	
    	if(el.element.type == 'signal') {
    		if(event.ctrlKey) { // ctrl+click: shunt train
    			return;
    		}
    		
    	}
*/
    });
	/*
	req = "/war/click?x=" + cell.x + "&y=" + cell.y + "&zoom=" + zooming + "&coord=" + coords;
	req += "&shift=" + (event.shiftKey ? "1" : "0");
	req += "&alt=" + (event.altKey ? "1" : "0");
	req += "&ctrl=" + (event.ctrlKey ? "1" : "0");
	req += "&btn=" + event.which;
	
	// TODO: if shift, it should be handled locally:
	//    lshift on station -> show station schedule
	//    lshift on train -> show train info
	//    lshift on signal -> set itinerary start
	//    altclick on train -> shunt / assign
	$.getJSON(req, function(data) {
		
	}).fail(function() {
		console.log("fail");
	});
	*/
}