var trainStopsTrain;        // TODO: make local to view instance
var trainStopsLink;

// update left panel of Train Stops view
function updateTrainsStop() {
    var schedFilter = $('#trainSelectorSearchInput').val();
    $('#trainSelectorSearchInput').on('input', function() {
        schedFilter = $(this).val(); // get the current value of the input field.
        updateTrainSelectorList(schedFilter);
    });
    updateTrainSelectorList(schedFilter);
}

function updateTrainSelectorList(filtr) {
	$.getJSON( "/war/trains.json", function( data ) {
		var titems = [];
		var i;
		for(i = 0; i < data.trains.length; ++i) {
		    var val = data.trains[i];
		    if(filtr && filtr.length > 0 && val.name.indexOf(filtr) < 0)
		        continue;
		    titems.push("<li class='trainListItem' onclick='selectedTrainStops(\"" + val.name + "\", \"" + val.link + "\");'>" + val.name + "</li>\n");
		}
		$("#trainSelector").html(titems.join(""));
	}).fail(function() {
		console.log("fail");
	});
}

function selectTrainInTrainList(name) {
	$(".trainListItem").each(function() {
		if($(this).text() == name) {
			this.style.color = "blue";
			$(this).css("font-weight", "bold")
		} else {
			this.style.color = "black";
			$(this).css("font-weight", "normal")
		}
	});
}

// update right panel of Train Stops view
function selectedTrainStops(name, link) {
    trainStopsTrain = name;
    trainStopsLink = link;
    var schedFilter = $('#trainStopsSearchInput').val();
    $('#trainStopsSearchInput').on('input', function() {
        schedFilter = $(this).val(); // get the current value of the input field.
        updateTrainStops(schedFilter);
    });
    updateTrainStops(schedFilter);
}

function updateTrainStops(filtr) {
	$.when( $.getJSON('/war/stops.json?t=' + trainStopsLink), $.getJSON('/war/trains.json') ).then(function( stops, trains ) {
		
		var items = [];
		var i;
		for(i = 0; i < stops[0].stops.length; ++i) {
		    var val = stops[0].stops[i];
		    if(filtr && filtr.length > 0) {
		        if(val.station.indexOf(filtr) < 0 &&
	                val.arrival.indexOf(filtr) < 0 &&
	                val.departure.indexOf(filtr) < 0)
		            continue;
		    }
		    items.push("<tr onclick='selectedStationItem(\"" + val.stationlink + "\", \"" + val.station + "\");'><td>" + val.station + "</td><td>" + val.arrival + "</td><td>" + val.departure + "</td></tr>\n");
		}
//		$.each(stops[0].stops, function( key, val ) {
//		});
        $("#trStopsTable").colResizable({liveDrag: true, postbackSafe: true });
		$("#trStopsTable tbody").html(items.join("\n"));
		selectTrainInTrainList(trainStopsTrain);
    });
}

